jQuery( document ).ready( function ( $ ) {
    "use strict";

    var booking_product_select = $( '#product_id' ),
        booking_form_wrapper   = $( '#yith-wcbk-create-booking-form-wrap' ),
        block_params           = {
            message:         null,
            overlayCSS:      {
                background: '#000',
                opacity:    0.6
            },
            ignoreIfBlocked: true
        };
    
    booking_product_select.on( 'change', function () {
        var product_id = $( this ).val();
        booking_form_wrapper.block( block_params );
        var post_data = {
            product_id: product_id,
            action:     'yith_wcbk_get_product_booking_form'
        };

        $.ajax( {
            type:     "POST",
            data:     post_data,
            url:      ajaxurl,
            success:  function ( response ) {
                booking_form_wrapper.html( response );
                $( document.body ).trigger( 'yith-wcbk-init-booking-form' );
            },
            complete: function () {
                booking_form_wrapper.unblock();
            }
        } );
    } );
} );