jQuery( document ).ready( function ( $ ) {
    "use strict";

    // Run tipTip
    $( document ).on( 'yith-wcbk-init-tiptip', function () {
        // Remove any lingering tooltips
        $( '#tiptip_holder' ).removeAttr( 'style' );
        $( '#tiptip_arrow' ).removeAttr( 'style' );
        $( '.tips' ).tipTip( {
                                 'attribute': 'data-tip',
                                 'fadeIn'   : 50,
                                 'fadeOut'  : 50,
                                 'delay'    : 200
                             } );
    } ).trigger( 'yith-wcbk-init-tiptip' );

    // Date Picker
    $( document ).on( 'yith-wcbk-init-datepickers', function () {
        $( '.date-picker' ).datepicker( {
                                            dateFormat     : 'yy-mm-dd',
                                            numberOfMonths : 1,
                                            showButtonPanel: true
                                        } );
    } ).trigger( 'yith-wcbk-init-datepickers' );

    // Copy on clipboard
    $( document ).on( 'click', '.yith-wcbk-copy-to-clipboard', function ( event ) {
        var target           = $( this ),
            selector_to_copy = target.data( 'selector-to-copy' ),
            obj_to_copy      = $( selector_to_copy );

        if ( obj_to_copy.length > 0 ) {
            var temp = $( "<input>" );
            $( 'body' ).append( temp );

            temp.val( obj_to_copy.html() ).select();
            document.execCommand( "copy" );

            temp.remove();
        }
    } );

    // Settings show conditional: show/hide element based on other element value
    $( '.yith-wcbk-show-conditional' ).hide().each( function () {
        var $show_conditional = $( this ),
            field_id          = $show_conditional.data( 'field-id' ),
            $field            = $( '#' + field_id ),
            value             = $show_conditional.data( 'value' );

        if ( $field.length > 0 ) {
            $field.on( 'change keyup', function () {
                if ( $field.val() == value ) {
                    $show_conditional.show();
                } else {
                    $show_conditional.hide();
                }
            } ).trigger( 'change' );
        }
    } );

    // Move
    $( '.yith-wcbk-move' ).each( function () {
        var $to_move = $( this ),
            after    = $to_move.data( 'after' );

        if ( after.length > 0 ) {
            $to_move.insertAfter( after ).show();
        }
    } );
} );
