jQuery( document ).ready( function ( $ ) {
    "use strict";

    /** -------------------------------------------------------------------------------
     *                     D a t e   a n d   T i m e   P i c k e r
     * --------------------------------------------------------------------------------
     */
        var datepickerFormat = 'yy-mm-dd';
    $( '.yith-wcbk-admin-date-picker' ).datepicker( {
                                                        dateFormat   : datepickerFormat,
                                                        showAnim     : false,
                                                        beforeShow   : function () {
                                                            $( '#ui-datepicker-div' ).addClass( 'yith-wcbk-datepicker' );
                                                        },
                                                        onClose      : function ( selectedDate ) {
                                                            $( '#ui-datepicker-div' ).removeClass( 'yith-wcbk-datepicker' );
                                                        }
                                                    } );

    /** ------------------------------------------------------------------------
     *  PRINTER - OnOff
     * ------------------------------------------------------------------------- */
    $.fn.yith_wcbk_onoff = function ( options ) {
        $( this ).each( function () {
            var hidden_input   = $( this ).children( '.yith-wcbk-on-off-value' ).first(),
                button         = $( this ).children( '.yith-wcbk-on-off' ).first(),
                enabled_class  = button.data( 'enabled_class' ),
                disabled_class = button.data( 'disabled_class' ),
                enabled_text   = button.data( 'enabled_text' ),
                disabled_text  = button.data( 'disabled_text' );

            button.on( 'click', function () {
                var value = hidden_input ? hidden_input.val() : 'no';
                if ( value === 'yes' ) {
                    hidden_input.val( 'no' );
                    button.removeClass( enabled_class );
                    button.addClass( disabled_class );
                    button.html( disabled_text );
                } else {
                    hidden_input.val( 'yes' );
                    button.removeClass( disabled_class );
                    button.addClass( enabled_class );
                    button.html( enabled_text );
                }
            } );

            $( this )
                .on( 'enable', function () {
                    hidden_input.val( 'no' );
                    button.trigger( 'click' );
                } )

                .on( 'disable', function () {
                    hidden_input.val( 'yes' );
                    button.trigger( 'click' );
                } )

        } );
    };

    
    $( '.yith-wcbk-on-off-container' ).yith_wcbk_onoff();

    /** -------------- Select2 - Select All | Deselect All -------------- */
    var select_all_btn   = $( '.yith-wcbk-select2-select-all' ),
        deselect_all_btn = $( '.yith-wcbk-select2-deselect-all' );

    select_all_btn.on( 'click', function () {
        var select_id     = $( this ).data( 'select-id' ),
            target_select = $( '#' + select_id );

        target_select.find( 'option' ).prop( 'selected', true );
        target_select.trigger( 'change' );
    } );

    deselect_all_btn.on( 'click', function () {
        var select_id     = $( this ).data( 'select-id' ),
            target_select = $( '#' + select_id );

        target_select.find( 'option' ).prop( 'selected', false );
        target_select.trigger( 'change' );
    } );
} );