/* global yith_wcbk_enhanced_select_params */
/* global yith_booking_globals */

jQuery( document ).ready( function ( $ ) {
    "use strict";

    // Order Search
    $( '.yith-wcbk-order-search' ).filter( ':not(.enhanced)' ).each( function () {
        var select2_args           = {
            allowClear        : true,
            placeholder       : $( this ).data( 'placeholder' ),
            minimumInputLength: $( this ).data( 'minimum_input_length' ) ? $( this ).data( 'minimum_input_length' ) : '1',
            escapeMarkup      : function ( m ) {
                return m;
            },
            ajax              : {
                url        : ajaxurl,
                dataType   : 'json',
                quietMillis: 250,
                data       : function ( term, page ) {
                    return {
                        term    : term,
                        action  : 'yith_wcbk_json_search_order',
                        security: yith_wcbk_enhanced_select_params.search_orders_nonce
                    };
                },
                results    : function ( data, page ) {
                    var terms = [];
                    if ( data ) {
                        $.each( data, function ( id, text ) {
                            terms.push( { id: id, text: text } );
                        } );
                    }
                    return { results: terms };
                },
                cache      : true
            }
        };
        select2_args.multiple      = false;
        select2_args.initSelection = function ( element, callback ) {
            var data = { id: element.val(), text: element.attr( 'data-selected' ) };
            return callback( data );
        };
        $( this ).select2( select2_args ).addClass( 'enhanced' );
    } );

    // Booking Product Search
    $( '.yith-booking-product-search' ).filter( ':not(.enhanced)' ).each( function () {
        var select2_args           = {
            allowClear        : $( this ).data( 'allow_clear' ) ? true : false,
            placeholder       : $( this ).data( 'placeholder' ),
            minimumInputLength: $( this ).data( 'minimum_input_length' ) ? $( this ).data( 'minimum_input_length' ) : '3',
            escapeMarkup      : function ( m ) {
                return m;
            },
            ajax              : {
                url        : ajaxurl,
                dataType   : 'json',
                quietMillis: 250,
                data       : function ( term, page ) {
                    return {
                        term    : term,
                        action  : 'yith_wcbk_json_search_booking_products',
                        security: yith_wcbk_enhanced_select_params.search_bookings_nonce
                    };
                },
                results    : function ( data, page ) {
                    var terms = [];
                    if ( data ) {
                        $.each( data, function ( id, text ) {
                            terms.push( { id: id, text: text } );
                        } );
                    }
                    return { results: terms };
                },
                cache      : true
            }
        };
        select2_args.multiple      = false;
        select2_args.initSelection = function ( element, callback ) {
            var data = { id: element.val(), text: element.attr( 'data-selected' ) };
            return callback( data );
        };
        $( this ).select2( select2_args ).addClass( 'enhanced' );
    } );
} );