<?php
/**
 * Booking Notes Metabox
 *
 * @author  Yithemes
 * @package YITH Booking for WooCommerce Premium
 * @version 1.0.0
 * @var YITH_WCBK_Booking $booking
 * @var array             $notes
 */
!defined( 'YITH_WCBK' ) && exit; // Exit if accessed directly

?>
<ul class="order_notes">
    <?php if ( !!$notes && is_array( $notes ) ): ?>
        <?php foreach ( $notes as $note ) :
            $note_classes = array( 'note' );
            $note_classes[] = 'admin' !== $note->type ? 'system-note' : '';
            ?>
            <li rel="<?php echo absint( $note->id ); ?>" class="<?php echo esc_attr( implode( ' ', $note_classes ) ); ?>">
                <div class="note_content">
                    <?php echo wpautop( wptexturize( wp_kses_post( $note->description ) ) ); ?>
                </div>
                <p class="meta">
                    <abbr class="exact-date"
                          title="<?php echo $note->note_date; ?>"><?php printf( __( 'added on %1$s at %2$s', 'yith-booking-for-woocommerce' ), date_i18n( wc_date_format(), strtotime( $note->note_date ) ), date_i18n( wc_time_format(), strtotime( $note->note_date ) ) ); ?></abbr>
                </p>
            </li>
        <?php endforeach; ?>
    <?php else: ?>
        <li> <?php _e( 'There are no notes.', 'yith-booking-for-woocommerce' ) ?></li>
    <?php endif; ?>
</ul>