<?php
/**
 * DB class
 *
 * @author  Yithemes
 * @package YITH Booking for WooCommerce Premium
 * @version 1.0.0
 */


if ( !defined( 'YITH_WCBK' ) ) {
    exit;
} // Exit if accessed directly

if ( !class_exists( 'YITH_WCBK_DB' ) ) {
    /**
     * YITH Booking for WooCommerce Premium Database
     *
     * @since 1.0.0
     */
    class YITH_WCBK_DB {

        /**
         * DB version
         *
         * @var string
         */
        public static $version = '1.0.0';

        public static $booking_notes_table = 'yith_wcbk_booking_notes';


        /**
         * Constructor
         *
         * @return YITH_WCBK_DB
         */
        private function __construct() {
        }

        public static function install() {
            self::create_db_table();
        }

        /**
         * create table for Notes
         *
         * @param bool $force
         */
        public static function create_db_table( $force = false ) {
            global $wpdb;

            $current_version = get_option( 'yith_wcbk_db_version' );

            if ( $force || $current_version != self::$version ) {
                $wpdb->hide_errors();

                $table_name      = $wpdb->prefix . self::$booking_notes_table;
                $charset_collate = $wpdb->get_charset_collate();

                $sql
                    = "CREATE TABLE $table_name (
                    `id` bigint(20) NOT NULL AUTO_INCREMENT,
                    `booking_id` bigint(20) NOT NULL,
                    `type` varchar(255) NOT NULL,
                    `description` TEXT NOT NULL,
                    `note_date` datetime NOT NULL,
                    PRIMARY KEY (id)
                    ) $charset_collate;";

                if ( !function_exists( 'dbDelta' ) ) {
                    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
                }
                dbDelta( $sql );
                update_option( 'yith_wcbk_db_version', self::$version );
            }
        }

    }
}