<?php
if ( !defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly

/**
 * YITH WCBK Integration Class
 *
 * @class   YITH_WCBK_Integration
 * @package Yithemes
 * @since   1.0.1
 * @author  Yithemes
 *
 */
class YITH_WCBK_Integration {

    /**
     * Single instance of the class
     *
     * @var \YITH_WCBK_Integration
     */
    private static $_instance;

    /**
     * true if has the plugin active
     *
     * @var bool
     */
    protected $_plugin_active = false;

    /**
     * true if has the integration is active
     *
     * @var bool
     */
    protected $_integration_active = false;

    /**
     * Returns single instance of the class
     *
     * @param $plugin_active
     * @param $integration_active
     *
     * @return YITH_WCBK_Integration
     */
    public static function get_instance( $plugin_active, $integration_active ) {
        if ( is_null( static::$_instance ) ) {
            static::$_instance = new static( $plugin_active, $integration_active );
        }

        return static::$_instance;
    }

    /**
     * Constructor
     *
     * @param bool $plugin_active
     * @param bool $integration_active
     *
     * @access protected
     */
    protected function __construct( $plugin_active, $integration_active ) {
        $this->_plugin_active      = !!$plugin_active;
        $this->_integration_active = !!$integration_active;
    }

    /**
     * return true if the plugin is active
     *
     * @return bool
     */
    public function has_plugin_active() {
        return !!$this->_plugin_active;
    }

    /**
     * return true if the integration is active
     *
     * @return bool
     */
    public function is_active() {
        return !!$this->_integration_active;
    }
}