<?php
/**
 * Template options in WC Product Panel
 *
 * @author  Yithemes
 * @package YITH Booking for WooCommerce Premium
 * @version 1.0.0
 */

!defined( 'YITH_WCBK' ) && exit; // Exit if accessed directly


$printer      = YITH_WCBK_Printer();
$months_array = yith_wcbk_get_months_array();
$days_array   = yith_wcbk_get_days_array();

$product_availability = get_post_meta( $post_id, '_yith_booking_availability_range', true );
?>

<div class="options_group">

    <table id="yith-wcbk-booking-availability-table" class="yith-wcbk-booking-settings-table">
        <tr class="yith-wcbk-availability-row yith-wcbk-availability-default-row">
            <td class="yith-wcbk-availability-anchor">
                <?php
                $printer->print_field( array(
                                           'type'  => 'dashicon',
                                           'class' => 'dashicons-menu yith-wcbk-anchor',
                                       ) );
                ?>
            </td>
            <td class="yith-wcbk-availability-range-column">
                <div class="yith-wcbk-availability-range-column-ranges">
                    <div class="yith-wcbk-availability-range-column-ranges-date">

                        <?php
                        $printer->print_field( array(
                                                   'type'  => 'hidden',
                                                   'name'  => '_yith_booking_availability_range[type][]',
                                                   'value' => 'custom',
                                               ) );
                        $printer->print_field( array(
                                                   'type'  => 'text',
                                                   'class' => 'yith-wcbk-date-input-field',
                                                   'title' => __( 'From', 'yith-booking-for-woocommerce' ),
                                                   'name'  => '_yith_booking_availability_range[from][]',

                                               ) );
                        $printer->print_field( array(
                                                   'type'  => 'text',
                                                   'class' => 'yith-wcbk-date-input-field',
                                                   'title' => __( 'To', 'yith-booking-for-woocommerce' ),
                                                   'name'  => '_yith_booking_availability_range[to][]',

                                               ) );
                        ?>

                    </div>
                    <div class="yith-wcbk-availability-range-column-ranges-month">
                        <?php
                        $printer->print_field( array(
                                                   'type'              => 'hidden',
                                                   'name'              => '_yith_booking_availability_range[type][]',
                                                   'value'             => 'month',
                                                   'custom_attributes' => 'disabled="disabled"',

                                               ) );
                        $printer->print_field( array(
                                                   'type'              => 'select',
                                                   'class'             => 'yith-wcbk-month-range-select',
                                                   'title'             => __( 'From', 'yith-booking-for-woocommerce' ),
                                                   'name'              => '_yith_booking_availability_range[from][]',
                                                   'options'           => $months_array,
                                                   'custom_attributes' => 'disabled="disabled"',
                                               ) );
                        $printer->print_field( array(
                                                   'type'              => 'select',
                                                   'class'             => 'yith-wcbk-month-range-select',
                                                   'title'             => __( 'To', 'yith-booking-for-woocommerce' ),
                                                   'name'              => '_yith_booking_availability_range[to][]',
                                                   'options'           => $months_array,
                                                   'custom_attributes' => 'disabled="disabled"',
                                               ) );
                        ?>
                    </div>

                    <?php

                    $printer->print_field( array(
                                               'type'            => 'onoff',
                                               'container_class' => 'yith-wcbk-bookable-onoff',
                                               'enabled_class'   => 'yith-wcbk-bookable-onoff-enabled',
                                               'disabled_class'  => 'yith-wcbk-bookable-onoff-disabled',
                                               'enabled_text'    => __( 'Bookable', 'yith-booking-for-woocommerce' ),
                                               'disabled_text'   => __( 'Non-bookable', 'yith-booking-for-woocommerce' ),
                                               'name'            => '_yith_booking_availability_range[bookable][]',
                                               'value'           => 'yes',
                                           ) );
                    ?>
                </div>
                <div class="yith-wcbk-availability-range-column-days hidden">
                    <?php
                    $printer->print_field( array(
                                               'type'  => 'hidden',
                                               'class' => 'yith-booking-global-availability-days-enabled',
                                               'name'  => '_yith_booking_availability_range[days_enabled][]',
                                               'value' => 'no',
                                           ) );
                    foreach ( $days_array as $day_number => $day_name ) {
                        $day_name = substr( $day_name, 0, 3 );
                        $printer->print_field( array(
                                                   'type'            => 'onoff',
                                                   'container_class' => 'yith-wcbk-day-onoff',
                                                   'enabled_class'   => 'yith-wcbk-day-onoff-enabled',
                                                   'disabled_class'  => 'yith-wcbk-day-onoff-disabled',
                                                   'enabled_text'    => $day_name,
                                                   'disabled_text'   => $day_name,
                                                   'name'            => '_yith_booking_availability_range[days][' . $day_number . '][]',
                                                   'value'           => 'yes',
                                               ) );
                    }
                    ?>
                </div>
            </td>
            <td class="yith-wcbk-availability-actions-column">
                <span class="dashicons dashicons-screenoptions yith-wcbk-availability-toggle-visible"></span>
                <?php
                $printer->print_field( array(
                                           'type'  => 'dashicon',
                                           'class' => 'dashicons-no-alt yith-wcbk-delete',
                                       ) );
                ?>
            </td>
        </tr>
        <?php if ( $product_availability && is_array( $product_availability ) ) : ?>
            <?php foreach ( $product_availability as $single_availability ): ?>
                <tr class="yith-wcbk-availability-row ">
                    <td class="yith-wcbk-availability-anchor">
                        <?php
                        $printer->print_field( array(
                                                   'type'  => 'dashicon',
                                                   'class' => 'dashicons-menu yith-wcbk-anchor',
                                               ) );
                        ?>
                    </td>
                    <td class="yith-wcbk-availability-range-column">
                        <div class="yith-wcbk-availability-range-column-ranges">

                            <?php if ( $single_availability->type === 'custom' ) : ?>
                                <div class="yith-wcbk-availability-range-column-ranges-date">

                                    <?php
                                    $printer->print_field( array(
                                                               'type'  => 'hidden',
                                                               'name'  => '_yith_booking_availability_range[type][]',
                                                               'value' => 'custom',
                                                           ) );
                                    $printer->print_field( array(
                                                               'type'  => 'text',
                                                               'class' => 'yith-wcbk-date-input-field yith-wcbk-admin-date-picker',
                                                               'title' => __( 'From', 'yith-booking-for-woocommerce' ),
                                                               'name'  => '_yith_booking_availability_range[from][]',
                                                               'value' => $single_availability->from,

                                                           ) );
                                    $printer->print_field( array(
                                                               'type'  => 'text',
                                                               'class' => 'yith-wcbk-date-input-field yith-wcbk-admin-date-picker',
                                                               'title' => __( 'To', 'yith-booking-for-woocommerce' ),
                                                               'name'  => '_yith_booking_availability_range[to][]',
                                                               'value' => $single_availability->to,
                                                           ) );
                                    ?>
                                </div>
                            <?php elseif ( $single_availability->type === 'month' ) : ?>
                                <div class="yith-wcbk-availability-range-column-ranges-month">
                                    <?php
                                    $printer->print_field( array(
                                                               'type'  => 'hidden',
                                                               'name'  => '_yith_booking_availability_range[type][]',
                                                               'value' => 'month',
                                                           ) );
                                    $printer->print_field( array(
                                                               'type'    => 'select',
                                                               'class'   => 'yith-wcbk-month-range-select',
                                                               'title'   => __( 'From', 'yith-booking-for-woocommerce' ),
                                                               'name'    => '_yith_booking_availability_range[from][]',
                                                               'options' => $months_array,
                                                               'value'   => $single_availability->from,
                                                           ) );
                                    $printer->print_field( array(
                                                               'type'    => 'select',
                                                               'class'   => 'yith-wcbk-month-range-select',
                                                               'title'   => __( 'To', 'yith-booking-for-woocommerce' ),
                                                               'name'    => '_yith_booking_availability_range[to][]',
                                                               'options' => $months_array,
                                                               'value'   => $single_availability->to,
                                                           ) );
                                    ?>
                                </div>
                            <?php endif; ?>

                            <?php

                            $printer->print_field( array(
                                                       'type'            => 'onoff',
                                                       'container_class' => 'yith-wcbk-bookable-onoff',
                                                       'enabled_class'   => 'yith-wcbk-bookable-onoff-enabled',
                                                       'disabled_class'  => 'yith-wcbk-bookable-onoff-disabled',
                                                       'enabled_text'    => __( 'Bookable', 'yith-booking-for-woocommerce' ),
                                                       'disabled_text'   => __( 'Non-bookable', 'yith-booking-for-woocommerce' ),
                                                       'name'            => '_yith_booking_availability_range[bookable][]',
                                                       'value'           => $single_availability->bookable,
                                                   ) );
                            ?>
                        </div>
                        <div
                            class="yith-wcbk-availability-range-column-days <?php echo $single_availability->days_enabled !== 'yes' ? 'hidden' : '' ?>">
                            <?php
                            $printer->print_field( array(
                                                       'type'  => 'hidden',
                                                       'class' => 'yith-booking-global-availability-days-enabled',
                                                       'name'  => '_yith_booking_availability_range[days_enabled][]',
                                                       'value' => $single_availability->days_enabled,
                                                   ) );
                            foreach ( $days_array as $day_number => $day_name ) {
                                $value    = $single_availability->days_enabled === 'yes' ? ( isset( $single_availability->days[ $day_number ] ) ? $single_availability->days[ $day_number ] : $single_availability->bookable ) : $single_availability->bookable;
                                $day_name = substr( $day_name, 0, 3 );
                                $printer->print_field( array(
                                                           'type'            => 'onoff',
                                                           'container_class' => 'yith-wcbk-day-onoff',
                                                           'enabled_class'   => 'yith-wcbk-day-onoff-enabled',
                                                           'disabled_class'  => 'yith-wcbk-day-onoff-disabled',
                                                           'enabled_text'    => $day_name,
                                                           'disabled_text'   => $day_name,
                                                           'name'            => '_yith_booking_availability_range[days][' . $day_number . '][]',
                                                           'value'           => $value,
                                                       ) );
                            }
                            ?>
                        </div>
                    </td>
                    <td class="yith-wcbk-availability-actions-column">
                        <span class="dashicons dashicons-screenoptions yith-wcbk-availability-toggle-visible"></span>
                        <?php
                        $printer->print_field( array(
                                                   'type'  => 'dashicon',
                                                   'class' => 'dashicons-no-alt yith-wcbk-delete',
                                               ) );
                        ?>
                    </td>
                </tr>
            <?php endforeach; ?>
        <?php endif; ?>
    </table>

    <div class="yith-wcbk-bottom-actions yith-wcbk-right">
        <input type="button" id="yith-wcbk-availability-add-date-range" class="button"
               value="<?php _e( 'Add Date Range', 'yith-booking-for-woocommerce' ); ?>">
        <input type="button" id="yith-wcbk-availability-add-month-range" class="button"
               value="<?php _e( 'Add Month Range', 'yith-booking-for-woocommerce' ); ?>">
        <?php
        $global_availability      = __( 'Global Availability', 'yith-booking-for-woocommerce' );
        $global_availability_link = add_query_arg( array(
                                                       'page' => 'yith_wcbk_panel',
                                                       'tab'  => 'availability',
                                                   ), admin_url( 'admin.php' ) );
        $global_availability_html = "<a href='$global_availability_link' target='_blank'>$global_availability</a>";
        $note                     = sprintf( _x( 'Note: setting availability in this booking product will override %s settings', 'Note: setting availability in this booking product will override Global Availability settings', 'yith-booking-for-woocommerce' ), $global_availability_html );
        $note                     = "<span class='yith-wcbk-desc'>$note</span>";
        echo $note;
        ?>
    </div>
</div>