<?php
/**
 * Single Product Thumbnails
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/product-thumbnails.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see        https://docs.woothemes.com/document/template-structure/
 * @author        WooThemes
 * @package    WooCommerce/Templates
 * @version     2.3.0
 */

if ( !defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

global $post, $product, $woocommerce;

$attachment_ids = $product instanceof WC_Data ? $product->get_gallery_image_ids() : $product->get_gallery_attachment_ids();
$thumb_id       = get_post_thumbnail_id( $product->get_id() );

if ( $thumb_id ) {
    $attachment_ids = array_merge( array( $thumb_id ), $attachment_ids );
}


if ( $attachment_ids ) {
    $first_set = false;
    ?>
    <?php

    foreach ( $attachment_ids as $attachment_id ) {

        $classes = array( '' );

        $image_link = wp_get_attachment_url( $attachment_id );

        if ( !$image_link )
            continue;

        if ( !$first_set ) {
            $classes[] = 'current';
            $first_set = true;
        }

        $image_class = esc_attr( implode( ' ', $classes ) );

        ?>
        <div class="yith-wcbk-thumb <?php echo $image_class; ?>" style="background-image: url(<?php echo $image_link; ?>)"></div>
        <?php
    }

    ?>
    <?php
} else {
    ?>
    <div class="yith-wcbk-thumb current" style="background-image: url(<?php echo wc_placeholder_img_src(); ?>)"></div>
    <?php
}

if ( count( $attachment_ids ) > 1 ): ?>
    <div id="yith-wcbk-search-form-result-product-thumb-actions-<?php echo $product->get_id(); ?>" class="yith-wcbk-search-form-result-product-thumb-actions">
        <span class="yith-wcbk-search-form-result-product-thumb-action-prev dashicons dashicons-arrow-left-alt2"></span>
        <span class="yith-wcbk-search-form-result-product-thumb-action-next dashicons dashicons-arrow-right-alt2"></span>
    </div>
<?php endif; ?>
